; TPTR_ASM
; on Q3 and win1_qptr (Q40)
; 3rd March 2001
; BASIC keywords for use in QPTR_BASIC
;
; v 2.3 - Correctly signal faulty parameter if > 1 in GWWD
;
; V 2.2 - To allow for BUTTONs in finding promary window in M_SETUP
;
; v 1h8 - To alter method of finding primary window in M_SETUP (= v2.1)
;
; v 1f8 - Again enhance meaning of SPR_SZE - 11 Oct 2000
;
; v 1e8 - Enhance meaning of SPR_SZE - 12 Sep 2000
;
; v 1d8 - Some more colours added
;
; v 1c8 - Altered W_MAX
;
; v 1b8 - SWIN correctly adjusted arithmetic stack
;
; v 1.8 - M_SETUP altered to get the primary window
;	Treatment of arithmetic stack different for compiled
;	(This affects CHECK)
;
; v 1.7 - W_MAX now works for compiled programs
;
; v 1.6 - A3 now preserved during ALCHP
;
; v 1.5 - D5 used in place of D6 since CA_G... smashes the latter
;
; v 1.4 - sets the QDOS colours as byte values (eg GREY% = 255 not -1)
;
; v 1.3 - no longer sets status area to zero in DO_MDRW
;
	NOLIST
	IN	WIN1_SYS_EQUBAS_ASM
	IN	WIN1_LIB_FNPROC_ASM
	IN	WIN1_LIB_HED
;
VERSION	EQU	?"2.3"
IOP.WBLB	EQU	$73
IOP.WSPT	EQU	$76
IOP.RPTR	EQU	$71
IOP.PINF	EQU	$70
IOP.OUTL	EQU	$7A
IOP.FLIM	EQU	$6C
WM.FSIZE	EQU	$54
WD.ELEN	EQU	$A
WM.CHWIN	EQU	$40
WM.SETUP	EQU	4
WM.PRPOS	EQU	$C
WM.WDRAW	EQU	$1C
WM.PULLD	EQU	$10
WM.PANSC	EQU	$38
WWL_SKEY	EQU	$B
WM.MHIT	EQU	$34
WM.RPTR	EQU	$30
WM.SMENU	EQU	8
WM.INDEX	EQU	$24
WM.LDRAW	EQU	$2C
WM.MDRAW	EQU	$20
WM.STIOB	EQU	$50
WM.STLOB	EQU	$4C
WM.UNSET	EQU	$14
WM.WRSET	EQU	$18
WSI..CHG	EQU	0
WS_PTPOS	EQU	$20
WS_LITEM	EQU	$40
WW_NLITM	EQU	$68
WWL.ELEN	EQU	$16
WSP_WEVE	EQU	$15
PT..D0	EQU	16
PT..CAN	EQU	17
PT..HELP	EQU	18
PT..WMOV	EQU	19
PT..WSIZ	EQU	20
PT..ZZZZ	EQU	21
PT..WAKE	EQU	22
N_Jobs	EQU	4
;
	LIST
;
; Print message
;
	LEA	MES,A1
	MOVEA.L	BV_CHBAS(A6),A0
	MOVEA.L	(A0,A6.L),A0
	MOVEA.W	UT_MTEXT,A2
	JSR	(A2)
;
START	LEA	DEFINE,A1
	MOVEA.W	BP_INIT,A2
	JMP	(A2)
;
	HED	<"TurboPTR v ",VERSION,10>,MES
	DS.W	0
DEFINE
	PROC_START
	PF_NAME	BRCHP,BRCHP
	PF_NAME	WRSET,BWRSET
	PF_NAME	BWSPR,BWSPR
	PF_NAME	BWBLO,BWBLO
	PF_NAME	CLOS,CLOS
	PF_NAME	CHW,BCHWIN
	PF_NAME	SP0000,BSPSET
	PF_NAME	LDRW,D_LDRW
	PF_NAME	ADRW,M_ADRW
	PF_NAME	OUTL,BOUTL
	PF_NAME	STLOB,STLOB
	PF_NAME	STIOB,STIOB
	PF_NAME	HX,HX
	PF_NAME	UNST,BUNST
	PF_NAME	CH_USE,USE
	PROC_END
	FN_START
	PF_NAME	SPRS,SPR_SZE
	PF_NAME	SETUP,M_SETUP
	PF_NAME	PULLD,M_PULLD
	PF_NAME	PRPOS,M_PRPOS
	PF_NAME	RPTR,BRPTR
	PF_NAME	WRPTR,WRPTR
	PF_NAME	LACT,M_LACT
	PF_NAME	MACT,M_MACT
	PF_NAME	MDRW,M_MDRW
	PF_NAME	ODRW,M_ODRW
	PF_NAME	MHIT,M_MHIT
	PF_NAME	ACR,ACR
	PF_NAME	OHIT,OHIT
	PF_NAME	MEN,M_LMEN
	PF_NAME	SWIN,SWIN
	PF_NAME	PAPPL,wd_pappl%
	PF_NAME	PLITM,wd_plitm%	 6
	PF_NAME	PINFO,wd_pinfo%	 4
	PF_NAME	NXSC,wda_nxsc%	26
	PF_NAME	NYSC,wda_nysc%	28
	PF_NAME	EXT,wda_ext%	31
	PF_NAME	NROW,wda_nrow%	32
	PF_NAME	NCOL,wda_ncol%	30
	PF_NAME	POBL,wdi_pobl%	16
	PF_NAME	CLEN,wda_clen%	24
	PF_NAME	NROW,wda_blen%	32
	PF_NAME	GREY,GREY%	$FF
	PF_NAME	L_RED,L_RED%	$EA
	PF_NAME	L_GREEN,L_GREEN%	$DC
	PF_NAME	D_GREEN,D_GREEN%	$E4
	PF_NAME	D_RED,D_RED%	$D2
	PF_NAME	MUSTARD,MUSTARD%	$F2
	PF_NAME	WHITE,WHITE%	7
	PF_NAME	BLACK,BLACK%	0
	PF_NAME	RED,RED%		2
	PF_NAME	GREEN,GREEN%	4
	PF_NAME	CYAN,CYAN%	5
	PF_NAME	MAGENTA,MAGENTA%	3
	PF_NAME	YELLOW,YELLOW%	6
	PF_NAME	BLUE,BLUE%	1
	PF_NAME	AWHITE,AWHITE%	$FFFE
	PF_NAME	AGREEN,AGREEN%	$F800
	PF_NAME	ABLUE,ABLUE%	$3E
	PF_NAME	ARED,ARED%	$7C0
	PF_NAME	AYELLOW,AYELLOW%	$FFC0
	PF_NAME	ACYAN,ACYAN%	$F83E
	PF_NAME	AMAGENTA,AMAGENTA%	$7FE
	PF_NAME	OPE,OPE
	PF_NAME	GCU,GETCU
	PF_NAME	GCP,GETPX
	PF_NAME	GLEN,GLEN
	PF_NAME	PTR,IS_POINTER%
	PF_NAME	WH_P,WH_PTR
	PF_NAME	CH_SZ,BCHSZ
	PF_NAME	W_MAX,W_MAX
	PF_NAME	CHB,CH_BAS
	PF_NAME	AD_SUB,AD_SUB
	FN_END
;
; BWSPR(#ch,x,y,sprt) writes a sprite to position x,y in channel #ch
; BWBLO(#ch,x,y,blob,patt) writes a blob with pattern patt to position
;	x,y in channel #ch
;
BWSPR	MOVEQ	#IOP.WSPT,D5	mark "sprite"
	LEA	4*8(A3),A0	4 parameters needed
	BRA	BW_1
;
BWBLO	MOVEQ	#IOP.WBLB,D5	mark "blob"
	LEA	5*8(A3),A0	5 parameters needed
BW_1	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	MOVEA.L	A5,A4
	BTST	#7,1(A3,A6.L) #? . .
	BEQ	BAD_PARM	---->	. . no
	LEA	3*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#3,D3
	BNE	BAD_PARM ---->
	MOVEA.L	A5,A3
	MOVEA.L	A4,A5
	MOVEA.L	BV_CHBAS(A6),A0
	MOVE.W	(A1,A6.L),D0	channel number
	MULU.W	#$28,D0
	ADDA.L	D0,A0
	CMPA.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D0
	BLT	NOT_CHAN	---->
	MOVEA.L	D0,A4		keep ID in A4
	MOVEM.W	2(A1,A6.L),D6-7	x,y (which leaves top words zero)
	SWAP	D6
	ADD.L	D6,D7
	ADDQ.L	#6,BV_RIP(A6) adjust stack
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
;
; We have A4 = ID
;	D7 = x|y
;	D5 = IOP.WSPT or IOP.WBLB
;
	MOVEA.L	A4,A0		ID
	MOVEM.L	(A1,A6.L),A4-5	sprite/blob & -/pattern
	ADD.W	D3,D3
	ADD.W	D3,D3		(number of pars)*4
	LEA	(A1,D3.W),A1
	MOVE.L	A1,BV_RIP(A6) adjust stack
	BSR	GVEC_2		check pointer environment
	MOVEA.L	A4,A1		-> sprite/blob
	MOVEA.L	A5,A2		->   -   /pattern
	MOVE.L	D7,D1		x|y
	MOVEQ	#0,D2
	MOVEQ	#-1,D3		timeout
	MOVE.L	D5,D0
	TRAP	#3
	RTS			return to BASIC
;
; BCHWIN(wdef) moves the window
;
CHW	BSR	GWWD	wdef -> A4
	BSR	GVEC	vector -> A1
	MOVEA.L	(A4),A2	status area
	BSET	#PT..WMOV,WSP_WEVE(A2)
	JMP	WM.CHWIN(A1)
;
; BCHSZ(wwd) returns the x/y movement from WM.CHWIN
;
CH_SZ	BSR	GWWD
	BSR	GVEC
	MOVEA.L	(A4),A2	status area
	BSET	#PT..WSIZ,WSP_WEVE(A2)
	JSR	WM.CHWIN(A1)
	MOVE.L	D1,D5
	BRA	SE_3
;
; BUNST(wdef) unsets the window
;
UNST	BSR	GWWD	wdef -> A4
	BSR	GVEC
	JMP	WM.UNSET(A1)
;
; BRCHP(ad) RECHP's the area at ad
;
BRCHP	BSR	GWWD	address -> A4
	MOVEA.L	A4,A0
	MOVEQ	#MT_RECHP,D0
	TRAP	#1
	MOVEQ	#0,D0
	RTS
;
; SWIN(w%,n%,wdef) returns the ID for a window or object.
; w%=0 for information windows, n% = the number of window,
;   =1 for loose items,	  n% = the number of loose item,
;   =2 for application window,  n% = the number of the window.
;
SWIN	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	3 parameters needed
	LEA	2*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		get w% and n% . .
	BNE	BAD_PARM	---->
	MOVEM.W	(A1,A6.L),D5/D7	. . -> D5 & D7
	ADDQ.L	#4,BV_RIP(A6)
	MOVEA.L	A5,A3		point to the . . .
	LEA	8(A5),A5		. . . last parameter
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEA.L	(A1,A6.L),A4	wdef
	ADDQ.L	#4,BV_RIP(A6)
	BSR	GVEC
	MOVEQ	#-1,D2
	MOVE.W	D7,D1
	ADD.W	D5,D5
	ADD.W	D5,D5		4*w%
	JSR	$58(A1,D5.W)	to WM.SWINF, WM.SWLIT or WM.SWAPP
	BNE	BAD_PARM	---->
;
; Now A0 = ID of window with correct dimensions.
; We have to open a CON with these and return that.
; But first, get 8 bytes on the stack.
;
	LEA	GET_W,A2		EXTOP routine to get dimensions
	MOVEQ	#-1,D3		timeout
	MOVEQ	#SD_EXTOP,D0
	TRAP	#3
	MOVE.L	A1,D7
	MOVE.L	D1,D6
	BSR	OPE1		A0 & D5 = ID
	MOVEQ	#8,D1
	BSR	CHECK
	MOVEM.L	D6-7,(A1,A6.L)
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#-1,D3
	MOVEQ	#SD_WDEF,D0
	TRAP	#4
	TRAP	#3
	ADDQ.L	#8,BV_RIP(A6)	Restore stack
	TST.L	D0
	BNE	BAD_EXIT	---->
	BRA	SE_3
;
GET_W	MOVEA.L	SD_XMIN(A0),A1
	MOVE.L	SD_XSIZE(A0),D1
	MOVEQ	#0,D0
	RTS
;
; STLOB(n%,ptr,wdef) sets the object @ ptr to the loose item n%,
; STIOB(w%,n%,ptr,wdef) sets the object @ ptr to item number n%
;      in information window number w%.
;
; In both cases wdef is the address of the window working definition.
;
STLOB	MOVEQ	#WM.STLOB,D5
	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	3 parameters needed
	MOVEA.L	A5,A4
	LEA	8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		get one integer
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7	n% -> D7
	ADDQ.L	#2,BV_RIP(A6)
STLOB_1	MOVEA.L	A5,A3
	MOVEA.L	A4,A5
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)		get ptr & wdef
	BNE	BAD_PARM	---->
	MOVEA.L	4(A1,A6.L),A4 wdef
	MOVEA.L	(A1,A6.L),A2	ptr
	BSR	GVEC		vector to A1
	EXG	A1,A2
	MOVE.L	D7,D1
	JMP	(A2,D5.W) do WM.STLOB or WM.STIOB
;
STIOB	MOVEQ	#WM.STIOB,D5
	LEA	4*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	4 parameters needed
	MOVEA.L	A5,A4
	LEA	16(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),D7	window no | object no
	ADDQ.L	#4,BV_RIP(A6)
	BRA	STLOB_1
;
; SPR_SZE(w%,h%) returns the space needed for a sprite of width w%
; and height h%. These dimensions must be < 2048
;
; If w% & h% > 0 a QL Mode  assumed - if w% < 0 a Mode 31 is assumed (Palette)
;			      - if h% < 0 a Mode 33 is assumed (Q40 Native)
;
SPRS	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	SUBQ.W	#2,D3
	BNE	BAD_PARM	---->	2 parameters needed
	MOVE.W	#$800,D3		Maximum size of dimension
	MOVEQ	#24,D5		Constant part
	MOVE.W	(A1,A6.L),D0	width (neg for Palette)
	BPL	SPRS_1		QL Mode
	NEG.W	D0
	MOVEQ	#3,D4		up to multiple of 4
	BRA	SPRS_2
SPRS_1	MOVEQ	#15,D4		up to multiple of 16
SPRS_2	MOVE.W	2(A1,A6.L),D2	h% (Neg -> Mode 33)
	BPL	SPRS_5		not Mode 33
	MOVEQ	#1,D4
	NEG.W	D2
SPRS_5	ADD.W	D4,D0
	NOT.W	D4
	AND.W	D4,D0
	CMP.W	D3,D0
	BGT	BAD_PARM	---->
	BTST	#2,D4
	BEQ	SPRS_3		QL Mode
	ADD.W	D0,D0		x2
	BTST	#1,D4
	BEQ	SPRS_4
	ADD.W	D0,D0		x4 for Mode 33
	BRA	SPRS_4
SPRS_3	LSR.W	#1,D0		/2 for QL
SPRS_4
	ADDQ.L	#4,BV_RIP(A6) tidy stack
	CMP.W	D3,D2
	BGT	BAD_PARM	---->
	MULU.W	D0,D2
	ADD.L	D2,D5		answer
	BRA	SE_3
;
; CH_BAS(ID) returns the base of channel ID
;
CHB	BSR	GWWD		ID -> A4
	MOVEA.L	A4,A0
	MOVEQ	#-1,D3		timeout
	LEA	F_CH,A2
	MOVEQ	#SD_EXTOP,D0
	TRAP	#3
	TST.L	D0
	BNE	BAD_EXIT	---->
	MOVE.L	A1,D5		address to D5
	BRA	SE_3
;
F_CH	MOVEA.L	A0,A1
	MOVEQ	#0,D0
	RTS
;
; BOUTL sets #0 (SBASIC or Master Basic) to managed, while leaving
; #0 unchanged. Nothing is done if the window is already managed.
;
; W_MAX returns the maximum size of window
;
OUTL:	MOVEQ	#0,D7		mark BOUTL
	BRA	OUTL_3
W_MAX	MOVEQ	#1,D7		mark W_MAX
OUTL_3	TST.B	$54(A6)
	BPL	OUTL_1		not SBASIC
	CMPI.L	#"SBAS",-4(A6)
	BEQ	SBAS		SBASIC
	TST.L	D7
	BEQ	NOT_IMP		don't do if compiled and BOUTL
	BSR	OPE1		Compiled - so need a channel . .
	MOVEQ	#-1,D7		. . and mark D7 to say so
	BRA	OUTL_2
OUTL_1	SUBA.L	A0,A0		ID #0
OUTL_2	MOVEQ	#-16,D0		space needed in buffer
	SUB.L	BV_BFBAS(A6),D0
	ADD.L	BV_TKBAS(A6),D0
	BMI	BUF_FUL	---->
	MOVEQ	#IOP.PINF,D0
	MOVEQ	#-1,D3		timeout
	TRAP	#3		see if pointer installed
	TST.L	D0
	BNE	BAD_EXIT	---->
	BSR	SET_WIN		put largest window -> Bas Buf
	MOVE.L	(A1,A6.L),D5	Maximum size to D5
	TST.L	D7
	BEQ	OUTL_4		BOUTL
	BPL	SE_3		W_MAX - no window to close
	BSR	CLOS_1		Here there is!
	BRA	SE_3
OUTL_4	MOVEQ	#SD_PXENQ,D0	to get cursor position
	TRAP	#4		A1 is relative to A6
	TRAP	#3
	MOVE.L	(A1,A6.L),D4	current window size to D4
	MOVE.L	4(A1,A6.L),D6	cursor pixel position to D6
	LEA	GET_W,A2		routine to get the origin
	MOVEQ	#SD_EXTOP,D0
	TRAP	#3
	MOVE.L	A1,D7		sets the origin to D7
	MOVEA.L	BV_BFBAS(A6),A1	big size . .
	MOVE.L	D5,(A1,A6.L)	. . to buffer . .
	CLR.L	4(A1,A6.L)	. . and zero origin
	MOVEQ	#0,D1		no shadow
	MOVEQ	#0,D2		don't keep contents
	MOVEQ	#IOP.OUTL,D0
	TRAP	#4
	TRAP	#3		do the OUTLINE
	TST.L	D0
	BNE	BAD_EXIT	---->
	MOVE.L	D4,(A1,A6.L)	set current window size . .
	MOVE.L	D7,4(A1,A6.L)	. . and origin
	MOVEQ	#0,D1		no . . .
	MOVEQ	#0,D2		. . . border
	MOVEQ	#SD_WDEF,D0
	TRAP	#4
	TRAP	#3
	MOVE.W	D6,D2		cursor . . .
	SWAP	D6
	MOVE.W	D6,D1		. . . position
	MOVEQ	#SD_PIXP,D0
	TRAP	#3
	RTS
;
NOT_IMP	MOVEQ	#-19,D0
	BRA	BAD_EXIT
BUF_FUL	MOVEQ	#-5,D0
	BRA	BAD_EXIT
;
SBAS	MOVE.L	BV_CHBAS(A6),A0
	MOVE.L	(A6,A0.L),D0	ID of #0
	BLT	NOT_CHAN	---->
	MOVEA.L	D0,A0		set ID in A0
	BRA	OUTL_2
;
MUSTARD	MOVEQ	#$F2,D5
	BRA	DIB1
WHITE	MOVEQ	#7,D5
	BRA	DIB
BLACK	MOVEQ	#0,D5
	BRA	DIB
BLUE	MOVEQ	#1,D5
	BRA	DIB
MAGENTA	MOVEQ	#3,D5
	BRA	DIB
CYAN	MOVEQ	#5,D5
	BRA	DIB
YELLOW	MOVEQ	#6,D5
	BRA	DIB
RED	MOVEQ	#2,D5
	BRA	DIB
GREEN	MOVEQ	#4,D5
	BRA	DIB
GREY	MOVEQ	#$FF,D5
	BRA	DIB1
L_RED	MOVEQ	#$EA,D5
	BRA	DIB1
L_GREEN	MOVEQ	#$DC,D5
	BRA	DIB1
D_GREEN	MOVEQ	#$E4,D5
	BRA	DIB1
D_RED	MOVEQ	#$D2,D5
	BRA	DIB1
AWHITE	MOVEQ	#$FE,D5
	BRA	DIB
AGREEN	MOVE.W	#$F800,D5
	BRA	DIB
ABLUE	MOVEQ	#$3E,D5
	BRA	DIB
ARED	MOVE.W	#$7C0,D5
	BRA	DIB
AYELLOW	MOVEQ	#-64,D5
	BRA	DIB
ACYAN	MOVE.W	#$F83E,D5
	BRA	DIB
AMAGENTA	MOVE.W	#$7FE,D5
	BRA	DIB
PAPPL	MOVEQ	#8,D5
	BRA	DIB
PLITM	MOVEQ	#6,D5
	BRA	DIB
PINFO	MOVEQ	#4,D5
	BRA	DIB
NXSC	MOVEQ	#26,D5
	BRA	DIB
NYSC	MOVEQ	#28,D5
	BRA	DIB
EXT	MOVEQ	#31,D5
	BRA	DIB
NROW	MOVEQ	#32,D5
	BRA	DIB
NCOL	MOVEQ	#30,D5
	BRA	DIB
POBL	MOVEQ	#16,D5
	BRA	DIB
CLEN	MOVEQ	#24,D5
DIB1	ANDI.W	#$FF,D5	keep byte value
DIB	MOVEQ	#2,D1	space for integer
	BSR	CHECK
	MOVE.W	D5,(A1,A6.L)
	MOVEQ	#3,D4	mark integer
	MOVEQ	#0,D0
	RTS
;
NOT_CHAN	MOVEQ	#-6,D0
	RTS
;
BAD_PARM	MOVEQ	#-15,D0
BAD_EXIT	RTS
;
; To reserve D1.L places on the arithmetic stack
; setting BV_RIP and A1 accordingly.
;
CHECK	MOVE.L	D1,-(A7)	keep the size needed
	bsr	Tstcmpld	compiled? . .
	bne.s	LAB106E	. . yes
	MOVEA.W	BV_CHRIX,A1
	JSR	(A1)
CHECK_1	MOVEA.L	$58(A6),A1
	SUBA.L	(A7)+,A1
	MOVE.L	A1,$58(A6)
	RTS
;
LAB106E	ADDQ.L	#2,D1		see that there are 2 more bytes as well
	NEG.L	D1
	ADD.L	$58(A6),D1	new value of stack in D1
	CMP.L	(A6),D1		is it OK? . .
	bpl.s	CHECK_1		. . yes
	moveq	#-3,d0		ERR.OM
	addq.l	#8,a7
	rts
*
* The following routine (from TurboToolkit)tests
* whether the calling job
* is running under a SuperBASIC Interpreter
* or a Compiled Job
* It should work under most QDOS variants
* and it works in current versions of SBASIC
*
* Idea gained from dissasembly of SMSQ/E JOB_NAME
* Procedure and comments in source of ENV_BIN
* assumes A6 points to basic variables
* No registers are corrupted
* only CCR is changed
*
* DCG
*
* PS If someone foolishly changes
* the appropriate area ie -4(A6)
* with a POKE on their heads be it
* That is also reason for checking
* what OS we are running under
*
Tstcmpld	movem.l	  d0-d2/a0,-(a7)
	tst.l	  $54(a6)
	beq.s	  Compiled	    for Qliberator DCG
	tst.b	  $54(a6)
	bpl.s	  Interp
	cmpi.l	  #'SBAS',-4(a6)
	bne.s	  Compiled
	moveq	  #0,d0
	trap	  #1
	cmpi.l	  #'SMSQ',(a0)
	bne.s	  Compiled
	cmpi.l	  #'2.00',d2
	blt.s	  Compiled
Interp	moveq	  #0,d0
	bra.s	  Myexit
Compiled	moveq	  #1,d0
Myexit	movem.l	  (a7)+,d0-d2/a0
	rts
;
; M_SETUP(#ch,wdef,size) is a function returning the address of the working
; definition.
;
; ch is the number of a BASIC CON channel
; ch > 99 if a primary window is wanted
;
; wdef is the address returned by M_WDEF
;
; To allow event sprites to be used as loose items, the first 10
; loose items can be designated as such. This is done by using the
; last 10 bytes of the loose item status area to hold the sprite
; number. This is placed in the working definition address in place
; of a real address.
;
; The status area for loose items is 40 bytes long - allowing 10
; "event" items and 20 others.
;
; The rth byte in the last ten refers to the rth loose item.
;
; Because it appears that the system of odd word pointers does not
; work relative to the status area, M_SETUP also sets the true
; addresses for pointers to menu control sections and the menu status
; area for all application windows.
;
SETUP	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	not 3 parameters
	BTST	#7,1(A3,A6.L)	#? . .
	BEQ	BAD_PARM	---->	. . no
	LEA	8(A3),A5		to get one parameter
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7	channel number
	ADDQ.L	#2,BV_RIP(A6)	reset BV_RIP
	MOVEA.L	A5,A3
	LEA	16(A3),A5 	prepare to get the next 2 parameters
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEM.L	(A1,A6.L),A3-4	address of window definition & size
	ADDQ.L	#8,BV_RIP(A6)	tidy stack
;
; Get ID
;
	MOVE.W	D7,D6
	SUBI.W	#100,D6		is a primary wanted? . .
	BPL	SETUP_PRIM
	MOVEA.L	BV_CHBAS(A6),A0
	MULU	#$28,D7
	ADDA.L	D7,A0
	CMP.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D7	ID -> D7.L
	TST.W	D7
	BMI	NOT_CHAN	---->


SETUP_11	MOVEA.L	D7,A0
	BSR	GVEC_2
;
; A1 contains qptr vector
;
	MOVEA.L	A1,A2
	MOVE.L	A4,D1		default size
	JSR	WM.FSIZE(A2)
;
; D2 = layout number : D1 = size of window
; A0 = ID : A2 = vector : A3 = wdef
;
	MOVEA.L	A3,A1
	LEA	$30(A1),A1
SETUP_1	TST.W	(A1)+
	BMI	SETUP_2		end of repeated bits
	LEA	WD.ELEN-2(A1),A1	to next bit
	BRA	SETUP_1
;
SETUP_PRIM:
	MOVEQ	#MT_INF,D0
	TRAP	#1
	MOVEA.L	SV_CHTOP(A0),A5
	MOVEA.L	SV_CHBAS(A0),A1
	MOVE.L	(A1)+,D7		Channel #0
	BMI	NOT_CHAN	---->
	MOVEA.L	D7,A2
	MOVE.L	CH_DRIVR(A2),D3	Driver (of CON)?
	MOVEA.L	D3,A2
	CMPI.L	#"Syst",$4A(A2)	Is System asleep? . .
	BNE	SETUP_P1		. . no
	MOVE.L	$20(A2),D3	Put the real driver address -> D3
SETUP_P1	CMPA.L	A5,A1		Ended? . .
	BGE	NOT_CHAN	---->	. .	Yes
	MOVE.L	(A1)+,D7
	BMI	SETUP_P1		Not a channel
	MOVEA.L	D7,A2
	CMP.L	CH_DRIVR(A2),D3	CON? . .
	BNE	SETUP_P1		. . no
	CMP.L	CH_OWNER(A2),D1	This Job's channel? . .
	BNE	SETUP_P1		. . no
	BTST	#7,$41(A2)	Primary? . .
	BEQ	SETUP_P1		. . no
	MOVE.L	A1,D7
	SUB.L	SV_CHBAS(A0),D7
	LSR.W	#2,D7		Channel . .
	SUBQ.W	#1,D7		. . number
	SWAP	D7
	MOVE.W	CH_TAG(A2),D7	Tag
	SWAP	D7		ID
	BRA	SETUP_11
;
SETUP_2	MOVE.L	D1,D6		keep size
	ADD.W	D2,D2
	ADD.W	D2,D2		4*number
	MOVE.L	104(A1,D2.W),D1	size of ALCHP'd area needed
	BSR	ALCH_1		sets address in A0 and D5
	MOVE.L	D6,D1		replace size
	MOVEA.L	A0,A4		address for working definition
	MOVEA.L	D7,A0		ID
	JSR	WM.SETUP(A2)	done
;
; Here we set the correct long word pointers to control blocks
; and status area for application windows
;
; A1 -> status area
; A4 -> working definition
;
	MOVE.L	$70(A4),A5	app window list
	MOVE.W	$6E(A4),D0	number of app windows
	BRA	SETUP_6
SETUP_7	MOVE.L	(A5)+,A3		-> app window block
	TST.L	$14(A3)		Is there a menu? . .
	BEQ	SETUP_6		. . no
	MOVEQ	#2*$1E,D4 	offset to last of pointers
	MOVEQ	#$1E,D1		distance between pointers
SETUP_8	MOVE.L	$28(A3,D4.W),D2	pointer to D2
	BSR	SET_ALT		set D2 to the correct address
	BEQ	SETUP_9		no alteration needed
	MOVE.L	D2,$28(A3,D4.W)	set correct address
SETUP_9	SUB.L	D1,D4		to previous pointer
	BPL	SETUP_8		more to come
SETUP_6	DBF	D0,SETUP_7	next app window
;
; To set event numbers if needed for a loose item sprite
;
	LEA	78(A1),A1 	-> 'event' area of loose
;				item status block
	MOVE.W	$68(A4),D0	number of loose items
	MOVEA.L	$6A(A4),A5	-> loose item list
	BRA	SETUP_3
SETUP_4	MOVE.B	(A1)+,D2		sprite number (if any)
	BEQ	SETUP_5		nothing to do
	CMPI.B	#2,$A(A5) 	type sprite? . .
	BNE	SETUP_5		. . no
	TST.L	$C(A5)		is the address really zero? . .
	BNE	SETUP_5		. . no!!!
	MOVE.B	D2,$C+3(A5)	set event sprite number
SETUP_5	LEA	WWL.ELEN(A5),A5	to next loose item
SETUP_3	DBF	D0,SETUP_4
;
; To set D5.L -> fp in D4.W & D5.L
;
SE_3	MOVE.W	D5,D4
	MOVE.L	D5,D1
	BEQ	SE_5
	MOVE.W	#$81F,D4		offset
	ADD.L	D1,D1
	BVS	SE_5
	SUBQ.W	#1,D4
	MOVE.L	D1,D5
	MOVEQ	#16,D0
SE_6	MOVE.L	D5,D1
	ASL.L	D0,D1
	BVS	SE_7
	SUB.W	D0,D4
	MOVE.L	D1,D5
SE_7	ASR.W	#1,D0
	BNE	SE_6
;
SE_5	MOVEQ	#6,D1		get 6 bytes on stack
	BSR	CHECK
	MOVE.L	D5,2(A1,A6.L)
	MOVE.W	D4,(A1,A6.L)
	MOVEQ	#2,D4		say 'fp'
EXIT	MOVEQ	#0,D0
	RTS
;
; SR to alter D2 to the correct offset from the status area
; Condition Code Zero set if no change
;
SET_ALT	BCLR	#0,D2		clear and test LS bit
	BEQ	SET_ALT1		nothing to do
	MOVEA.L	D2,A2
	ADD.L	(A2),D2		correct address
SET_ALT1	RTS
;
; M_PULLD(wwd,wh) and M_PRPOS(wwd,wh) return
; the ID of the window pulled down or positioned.
; wwd is the address returned by M_SETUP
; wh is the window "origin" (or -1)
;
PRPOS	MOVEQ	#WM.PRPOS,D5
	BRA	PULLD1
;
PULLD	MOVEQ	#WM.PULLD,D5
PULLD1	LEA	16(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	we need 2 parameters
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEA.L	(A1,A6.L),A4	wwd
	MOVE.L	4(A1,A6.L),D7	"origin"
	ADDQ.L	#8,BV_RIP(A6)
	BSR	GVEC
	MOVE.L	D7,D1
	JSR	(A1,D5.W) 	WM.PULLD or WM.PRPOS
	BNE	BAD_EXIT	---->
	JSR	WM.WDRAW(A1)
	BNE	BAD_EXIT	---->
	MOVE.L	A0,D5		ID -> D5.L
	BRA	SE_3
;
; BWRSET(wwd) resets and redraws the window @ working definition wwd
;
WRSET	BSR	GWWD		wwd -> A4
	BSR	GVEC		vector -> A1
	MOVEQ	#-1,D1
	JSR	WM.WRSET(A1)
	BNE	BAD_EXIT	---->
	JMP	WM.WDRAW(A1)
;
ALCH_1:
	MOVEM.L	D1/A1-3,-(A7)
	MOVEQ	#-1,D2		this JOB
	MOVEQ	#MT_ALCHP,D0
	TRAP	#1
	MOVEM.L	(A7)+,D1/A1-3
	TST.L	D0
	BNE	ALCH_E	---->	OOH!
	MOVE.L	A0,D5		keep address for return
	RTS
;
ALCH_E	ADDQ.L	#4,A7
	RTS
;
; To read the pointer and return on the conditions in
; termination vector k%.
;
; BRPTR(k%,ppos,wwd) returns the position of the pointer.
; k% is the termination record and wwd the working definition
; ppos is the initial position of the pointer.
;
RPTR	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	three parameters needed
	MOVEA.W	CA_GTINT,A2
	LEA	8(A3),A5
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D7	k% -> D7
	ADDQ.L	#2,BV_RIP(A6)
	ADDQ.L	#8,A3
	LEA	16(A3),A5
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),D1	initial position of pointer
	MOVEA.L	4(A1,A6.L),A1	working definition
	ADDQ.L	#8,BV_RIP(A6)
	MOVE.W	D7,D2		set termination vector
	MOVEQ	#-1,D3		timeout
	MOVEA.L	8(A1),A0		channel ID
	MOVEA.L	(A1),A1		status block
	ADDQ.L	#8,A1		-> pointer record
	MOVEQ	#IOP.RPTR,D0
	TRAP	#3
	MOVE.L	D1,D5		pointer position
RPTR_1	TST.L	D0		OK? . .
	BEQ	SE_3		. . yes
	RTS
;
; WRPTR returns the long word k after reading the
; pointer via the window manager.
;
; There should be a forced exit with non-zero D0.
;
; The third byte of k is -1 for a loose item, otherwise the application
; window number (0, 1, ...)
; The low word of k is the item number (0, 1, ...)
;
WRPTR	BSR	GWWD		working definition -> A4
	BSR	GVEC
	JSR	WM.RPTR(A1)
	MOVE.L	D0,D5
	BEQ	WRPTR1		event
	BRA	SE_3
;
WRPTR1	MOVE.W	#$10FE,D5
	SWAP	D5
	MOVEA.L	(A4),A2
	MOVE.B	$15(A2),D5	window event vector
	BRA	SE_3
;
; D_LDRW k,wdef redraws the loose item number n, with status s
; where k = 65536*s + n. The status, s, is 0 for available, 16
; for unavailable and 128 for selected.
;
LDRW	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)		get 2 long integers
	BNE	BAD_PARM	---->
	SUBQ.W	#2,D3
	BNE	BAD_PARM	---->	2 parameters needed
	MOVE.L	(A1,A6.L),D2	s | n
	MOVEA.L	4(A1,A6.L),A4 wdef
	ADDQ.L	#8,BV_RIP(A6)
	MOVE.W	D2,D4
	CMP.W	WW_NLITM(A4),D4
	BCC	BAD_PARM	---->
	SWAP	D2
	TST.W	D2
	BEQ	LDRW_1		OK
	CMP.W	#16,D2
	BEQ	LDRW_1
	CMP.W	#128,D2
	BNE	BAD_PARM	---->
LDRW_1	BSR	GVEC
	MOVEA.L	(A4),A3		status area
	ADDQ.W	#1,D2		mark 'redraw'
	MOVE.B	D2,WS_LITEM(A3,D4.W)
	MOVEQ	#-1,D3		selective redraw
	MOVEA.L	8(A4),A0		ID
	JSR	WM.LDRAW(A1)
	TST.L	D0
	BNE	BAD_EXIT
	BCLR	#WSI..CHG,WS_LITEM(A3,D4.W)
	BRA	EXIT
;
; M_ADRW(no%,wwd) selectively redraws the items in app window number no%.
; wwd is the address of the working definition
;
ADRW	LEA	2*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	two parameters needed
	LEA	8(A3),A5		set to get no%
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D5	number of window (0, 1, etc)
	ADDQ.L	#2,BV_RIP(A6) adjust stack
	MOVEA.L	A5,A3		prepare for next . .
	ADDQ.L	#8,A5		. . parameter
	BSR	GWWD		get wwd -> A4
	BSR	GVEC		ptr vector -> A1
	CMP.W	$6E(A4),D5	number of windows v no%
	BGE	BAD_PARM	---->	(window doesn't exist)
	ADD.W	D5,D5
	ADD.W	D5,D5
	MOVEA.L	$70(A4),A3	pointer to window list
	MOVEA.L	(A3,D5.W),A3	pointer to window
	MOVEQ	#-1,D3		selective redraw
	JMP	WM.MDRAW(A1)
;
; AD_SUB(wa%,o%,wwd) returns the address of the definition of a
; sub-window or loose item number wa% (0, 1 ..).
;
; o%= 0 for information windows
;     1	  application windows
;     2	  loose items
;
AD_SUB	LEA	3*8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->
	LEA	2*8(A3),A5
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEM.W	(A1,A6.L),D5/D7
	TST.W	D7
	BMI	BAD_PARM	---->
	CMPI.W	#2,D7
	BGT	BAD_PARM	---->
	ADDQ.L	#4,BV_RIP(A6)
	MOVEA.L	A5,A3
	LEA	8(A3),A5
	BSR	GWWD		wwd -> A4
	LSL.W	#3,D7		0, 8, 16
	LEA	AD_C(D7.W),A5	constants
	MOVE.W	(A5)+,D0
	CMP.W	(A4,D0.W),D5
	BGE	BAD_PARM	---->
	MOVE.W	(A5)+,D0
	MOVEA.L	(A4,D0.W),A0
	MULU.W	(A5)+,D5
	ADDA.L	D5,A0
	TST.W	(A5)
	BEQ	AD_SUB1		not app
	MOVEA.L	(A0),A0
AD_SUB1	MOVE.L	A0,D5
	BRA	SE_3
;
AD_C	DC.W	$60,$64,$14,0	INF
	DC.W	$6E,$70,$4,1	APP
	DC.W	$68,$6A,$16,0	LOOSE ITEM
;
; GCU (GETCU) ID returns the character cursor position (x*65532 + y)
; GCP (GETPX) ID returns the pixel cursor position (x*65532 + y)
;
GCU	MOVEQ	#SD_CHENQ,D5
	BRA	GCU1
GCP	MOVEQ	#SD_PXENQ,D5
GCU1	BSR	GWWD		ID -> A4
	MOVEA.L	A4,A0
	MOVEQ	#-1,D3
	MOVE.L	D5,D0
	TRAP	#0
	LINK	A5,#-8
	LEA	-8(A5),A1
	TRAP	#3
	TST.L	D0
	BNE	GCU_X	---->
	MOVE.L	-4(A5),D5 answer
	UNLK	A5
	ANDI	#$D8FF,SR
	BRA	SE_3
;
GCU_X	UNLK	A5
	ANDI	#$D8FF,SR
	BRA	BAD_EXIT	---->
;
; GLEN(<address>) returns the size of area needed to contain the
; string at <address>.
;
GLEN	BSR	GWWD	address -> A4
	MOVEQ	#0,D5	max characters in a line
	MOVEQ	#0,D2	no. of lines
	MOVE.W	(A4)+,D0	length of string
GLEN_1	SUBQ.W	#1,D0
	BMI	GLEN_3	done
	MOVE.W	D0,D3	count at start of line
	ADDQ.W	#1,D2	count lines
GLEN_2	CMPI.B	#10,(A4)+ LF? . . .
	DBEQ	D0,GLEN_2 . . . not yet
	BSR	G_MAX	set D5 to maximum line length so far
	BEQ	GLEN_1	more characters to look at
;
GLEN_3	SWAP	D5
	MOVE.W	D2,D5	max length | no. of lines
	BRA	SE_3	send answer
;
G_MAX	MOVE	CCR,-(A7)
	MOVE.W	D3,D1
	SUB.W	D0,D1	line length
	CMP.W	D1,D5
	BGT	G_MAX1
	MOVE.W	D1,D5
G_MAX1	RTR		return preserving COND CODES
;
LACTION	MOVEQ	#0,D4
	MOVE.W	#$10FF,D0
	SWAP	D0
	MOVE.W	$10(A3),D0	item number
	TST.L	D0
	RTS
;
; The action routine for an application window is called via WM.MHIT
; and refers to an item hit in the window.
;
; An exit from WM.RPTR is forced by setting a non-zero D0, which
; contains information. The third highest byte of D0 contains the
; application window number (0, 1, ...). The low word of D0 contains
; the item number (0, 1, ...).
;
MACTION	MOVEQ	#0,D4
	MOVEA.L	(A4),A1		status block
	MOVE.W	$C(A1),D0 	window number
	BSET	#14,D0		ensure non-zero D0
	SWAP	D0
	MOVE.W	D2,D0		item number
	TST.L	D0
	RTS
;
; MHITT calls WM.MHIT unless there is a 'do' or 'cancel'
; in which case D0 is set to $10yyFFFx where x=E for 'do' and F for 'cancel'
; and yy is the window number (0, 1, ...)
;
MHITT	TST.B	D4
	BEQ	MHITT2
	MOVEA.L	(A4),A1		status area
	TST.W	$30(A1)		is there an item? . .
	BMI	MHITT1		. . . no
MHITT2	JMP	WM.MHIT(A2)
MHITT1	MOVE.W	$C(A1),D0 	window number
	ORI.W	#$1000,D0 	ensure a non-zero D0
	SWAP	D0
	SUBI.W	#18,D4
	MOVE.W	D4,D0
	RTS
;
PANSC	JMP	WM.PANSC(A2)
;
OHT	JMP	WM.MHIT(A2)
;
SMEN	JMP	WM.SMENU(A2)
;
; DO_MDRW is the menu application drawing routine
; DO_ODRW is the drawing routine for a non menu application window
;
DO_MDRW	movea.l	$64(a3),a1	address of status area
	MOVE.W	$90(A3),D0	number of actual columns . .
	MULU.W	$92(A3),D0	. . x number of actual rows
	JSR	WM.INDEX(A2)
	BNE	DO_MDRW3
DO_ODRW	MOVEQ	#0,D3		draw all items
	JMP	WM.MDRAW(A2)
DO_MDRW3	RTS			---->
;
; LACT returns the address of the event action routine LACTION
;
LACT	LEA	LACTION,A0
LACT1	MOVE.L	A0,D5
	BRA	SE_3
;
; MACT returns the address of the menu action routine MACTION
;
MACT	LEA	MACTION,A0
	BRA	LACT1
;
; MHIT returns the address of the menu hit routine MHITT
;
MHIT	LEA	MHITT,A0
	BRA	LACT1
;
; ACR returns the address of the pan/scroll routine
;
ACR	LEA	PANSC,A0
	BRA	LACT1
;
; OHIT returns the address of the basic hit routine
;
OHIT	LEA	OHT,A0
	BRA	LACT1
;
; MEN returns the address of the standard set menu routine
;
MEN	LEA	SMEN,A0
	BRA	LACT1
;
; M_MDRW returns the address of the draw routine for a menu
;
MDRW	LEA	DO_MDRW,A0
	BRA	LACT1
;
ODRW	LEA	DO_ODRW,A0
	BRA	LACT1
;
; OPE returns the ID of a con channel opened
;
OPE1	MOVEQ	#1,D4		mark SR
	BRA	OPE2
;
OPE	MOVEQ	#0,D4		mark OPE
OPE2	LEA	CON,A0
	MOVEQ	#-1,D1		this JOB
	MOVEQ	#0,D3
	MOVEQ	#IO_OPEN,D0
	TRAP	#2
	MOVE.L	A0,D5		ID
	TST.B	D4
	BEQ	RPTR_1
	RTS
;
CON	DC.W	3
	DC.B	"CON"
;
; CLOS(chid) closes channel chid
;
CLOS	LEA	8(A3),A0
	CMPA.L	A0,A5
	BNE	BAD_PARM	---->	only one parameter wanted
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVE.L	(A1,A6.L),A0	ID
	ADDQ.L	#4,BV_RIP(A6)
CLOS_1	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	RTS
;
; IS_POINTER% returns 0 if no pointer environment, 1 otherwise
;
PTR	BSR	OPE1		set ID -> A0 . . .
	MOVE.L	A0,D6		. . . and D6
	MOVEQ	#-1,D3
	PEA	PTR_1
	BSR	GVEC_2
	MOVEQ	#1,D5		mark pointer present
	ADDQ.L	#4,A7		restore stack
	BRA	PTR_2
PTR_1	MOVEQ	#0,D5		mark pointer not present
PTR_2	MOVEA.L	D6,A0		restore ID
	BSR	CLOS_1		close channel
	BRA	DIB
;
; WH_PTR(wwd) returns the x,y coordinates of the pointer
;
WH_P	BSR	GWWD
	BSR	GVEC
	MOVEA.L	(A4),A1		status area
	MOVE.L	WS_PTPOS(A1),D5	pointer position
	BRA	SE_3		return it
;
; GVEC sets the ptr vector to A1
; on entry A4 -> wdef
; no other registers used except A0, D0 and D1
;
GVEC	MOVEA.L	8(A4),A0		set ID -> A0
GVEC_2	MOVEQ	#IOP.PINF,D0
	MOVEQ	#-1,D3		Timeout
	TRAP	#3
	TST.L	D0
	BEQ	GVEC_1
	ADDQ.L	#4,A7
GVEC_1	RTS
;
; GWWD reads one long integer parameter to A4
;
GWWD	LEA	8(A3),A0
	CMPA.L	A5,A0
	BNE	GBAD	---->
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	GBAD	---->
	SUBQ.W	#1,D3
	BNE	GBAD	---->
	MOVEA.L	(A1,A6.L),A4
	ADDQ.L	#4,BV_RIP(A6)
	RTS
;
GBAD	ADDQ.L	#4,A7
	BRA	BAD_PARM	---->
;
; BSPSET addr,xorg,yorg,md,l
;
;	addr is where the result will be put
;	xorg,yorg is the sprite's origin
;	md is the QL mode (4 or 8)
;	l is the address of the sprite's data in an ALCHPd area
;	 containing what looks like a SuperBASIC array but with
;	 the 1st long word being a pointer to data relative to the
;	 start of the area.
;
;	The data for the sprite consists of a string for each row
;	ending with a null string. Each string indicates the colour
;	for each pixel.
;
;	The colours are indicated by:
;		a	black
;		u	blue
;		r	red
;		m	magenta
;		g	green
;		c	cyan
;		y	yellow
;		w	white
;		SPACE	transparent
;
;      Code disassembled with IDIS.SE
;      (C) by PL 1989
      

SP0000
       MOVEA.W $0118,A2
       JSR	 (A2)
       BNE	 SP0001
       SUBQ.W  #$05,D3
       BNE	 SP0002
       MOVE.L  $00(A6,A1.L),D0
       BCLR	 #$00,D0
       BNE	 SP0002
       MOVEA.L D0,A0
       MOVE.W  $06(A6,A1.L),$0008(A0)
       MOVE.W  $0A(A6,A1.L),$000A(A0)
       MOVE.W  $0E(A6,A1.L),D0
       MOVEQ	 #$00,D1
       ANDI.W  #$00FB,D0
       BEQ.S	 SP0003
       MOVEQ	 #$01,D1

SP0003 ORI.W	 #$0100,D1
       MOVE.W  D1,(A0)
       CLR.W	 $0002(A0)
       MOVEA.L   $10(A6,A1.L),A2     address of sprite array
       CMPI.W  #$0002,$04(A2)
       BNE	SP0002
       MOVE.W  $06(A2),D6
       ADDQ.W  #$01,D6
       MOVE.W  $0A(A2),D5
       MOVE.W  $08(A2),D4

SP0006 MOVE.W  D6,$0006(A0)
       SWAP	 D6
       SUB.W	 D5,D4
       SUBQ.W  #$02,D4

SP0007 MOVEQ	 #$01,D0
       AND.W	 (A0),D0
       ADDQ.W  #$01,D0
       MOVE.L  D0,D3
       MOVE.W  D5,$0004(A0)
       MULU	 D5,D0
       BSR	 SP0008
       LEA	 $0018(A0),A3
       LEA	 $10(A0,D0.L),A4
       ADDA.L    (A2),A2   -> start of data
       LEA	 SP0009,A1
       CMPI.W  #$0001,D3
       BEQ.S	 SP0010
       LEA	 SP0011,A1

SP0010 BSR.S	 SP0012
       MULU	 $0004(A0),D3
       MOVE.W  D3,$0004(A0)
       MOVEQ	 #$00,D0

SP0001 RTS

SP0002 MOVEQ	 #-$0F,D0
       BRA.S	 SP0001

SP0012 BRA.S	 SP0013

SP0015 MOVE.W  (A1),D2

SP0022 SUB.L	 D3,D6
       TST.W	 D6
       BMI.S	 SP0016
       MOVEQ	 #$20,D1
       SUBQ.W  #$01,D7
       BMI.S	 SP0017
       MOVE.B  (A2)+,D1
       ORI.B	 #$20,D1

SP0017 MOVE.W  D2,D0
       NOT.W	 D0
       AND.W	 D0,(A3)
       AND.W	 D0,(A4)
       MOVEQ	 #$08,D0

SP0019 CMP.B	 SP0018(PC,D0.W),D1
       DBEQ	 D0,SP0019
       BNE.S	 SP0020
       ADD.W	 D0,D0
       BEQ.S	 SP0021
       MOVE.W  $02(A1,D0.W),D0
       AND.W	 D2,D0
       OR.W	 D0,(A3)
       OR.W	 D2,(A4)

SP0021 LSR.W	 D3,D2
       BCC.S	 SP0022
       CMPM.W  (A3)+,(A4)+
       BRA.S	 SP0015

SP0016 ADDA.W  D4,A2

SP0013 CLR.W	 D6
       MOVEQ	 #$00,D0
       TST.L	 D6
       BEQ.S	 SP0014
       MOVE.W  D5,D6
       MOVE.W  $0004(A0),D7
       MOVE.W  (A2)+,D7
       BRA.S	 SP0015

SP0020 MOVEQ	 #-$0F,D0

SP0014 RTS

SP0018 DC.B	 $20,$61
       DC.B	 $75,$72
       DC.B	 $6D,$67
       DC.B	 $63,$79
       DC.B	 $77,$00

SP0009 DC.B	 $80,$80
       DC.B	 $12,$34
       DC.B	 $00,$00
       DC.B	 $00,$00
       DC.B	 $00,$FF
       DC.B	 $00,$FF
       DC.B	 $FF,$00
       DC.B	 $FF,$00
       DC.B	 $FF,$FF
       DC.B	 $FF,$FF

SP0011 DC.B	 $C0,$C0
       DC.B	 $AB,$CD
       DC.B	 $00,$00
       DC.B	 $00,$55
       DC.B	 $00,$AA
       DC.B	 $00,$FF
       DC.B	 $AA,$00
       DC.B	 $AA,$55
       DC.B	 $AA,$AA
       DC.B	 $AA,$FF
       DC.B	 $00,$00

SP0008 ADDI.W  #$000F,D0
       ANDI.W  #$FFF0,D0
       MOVE.W  D0,D5
       ASR.W	 #2,D0
       MULU	 $0006(A0),D0
       ADDQ.L  #$08,D0
       MOVE.L  D0,$0010(A0)
       MOVE.L  #$0000000C,$000C(A0)
       CLR.L	 $0014(A0)
       RTS
;
; HX([#ch,] k) prints a long word k on channel #ch (default #1) as hex
;
HX	MOVEQ	#-10,D0		 space needed
	SUB.L	BV_BFBAS(A6),D0	 buffer top
	ADD.L	BV_TKBAS(A6),D0	 buffer base
	BMI	BUF_FUL	---->
	LEA	8(A3),A4		-> last parameter?
	MOVEQ	#1,D0		default channel -> D0
	BTST	#7,1(A3,A6.L)	#? . . .
	BEQ	HX_1		. . . no
	LEA	16(A3),A4 	-> last parameter!
	CMPA.L	A4,A5
	BNE	BAD_PARM	---->
	LEA	8(A3),A5		get one parameter
	MOVEA.W	CA_GTINT,A2
	JSR	(A2)		get channel number . .
	BNE	BAD_PARM	---->
	MOVE.W	(A1,A6.L),D0	. . . -> D0
	ADDQ.L	#2,BV_RIP(A6)	adjust stack
	LEA	8(A5),A5		to next . . .
	LEA	8(A3),A3		. . . parameter
HX_1	CMPA.L	A4,A5
	BNE	BAD_PARM	---->
	MULU.W	#$28,D0
	MOVEA.L	BV_CHBAS(A6),A0
	ADDA.L	D0,A0
	CMPA.L	BV_CHP(A6),A0
	BGE	NOT_CHAN	---->
	MOVE.L	(A0,A6.L),D0
	BLT	NOT_CHAN	---->
	MOVEA.L	D0,A4		keep ID
	MOVEA.W	CA_GTLIN,A2
	JSR	(A2)
	BNE	BAD_PARM	---->
	MOVEA.L	BV_BFBAS(A6),A0
	MOVE.B	#' ',(A0,A6.L)	set space to start
	ADDQ.L	#1,A0		make space for $
	MOVE.L	A0,D7		keep in D7
	MOVEA.W	CN_ITOHL,A2
	JSR	(A2)
	MOVEA.L	D7,A0		to start of hex number
	MOVEQ	#7,D0		count
	BRA	HX_2
HX_3	MOVE.B	#' ',(A0,A6.L)	replace '0' by SPACE
	ADDQ.L	#1,A0
HX_2	CMP.B	#'0',(A0,A6.L)
	DBNE	D0,HX_3		go on till not 0
	MOVE.B	#'$',-1(A0,A6.L)
;
; now the ASCII number (plus $) is in the basic buffer
;
	ADDQ.L	#4,BV_RIP(A6)	tidy stack
	MOVEA.L	A4,A0		ID
	MOVEA.L	BV_BFBAS(A6),A1	pointer to string (rel to A6)
	MOVEQ	#10,D2
	MOVE.B	D2,9(A1,A6.L)	LF
	MOVEQ	#-1,D3		timeout
	MOVEQ	#IO_SSTRG,D0
	TRAP	#4
	TRAP	#3
	RTS			return to BASIC (with any errors)
*
CH_USE	CMP.L	A3,A5	Pars?
	BNE.S	READ_CH	Yes
RESET_CHL MOVE.L	BV_CHBAS(A6),A1
	LEA	40(A1),A1
	LEA	JB_SP,A2
	MOVEQ	#MT_INF,D0	D1 = job ID
	TRAP	#1
	TRAP	#0
;
; Now in supervisor mode
;
	MOVE.W	SR,D7
	ORI	#$700,SR		stop interrupts
	MOVEQ	#N_Jobs-1,D2
L1	CMP.L	(A2)+,D1		see if this job in list
	DBEQ	D2,L1
	BNE	NO_ERROR1 ---->	not there
	MOVE.L	4*N_JOBS-4(A2),(A1,A6.L)	reset #ID
	ST	-2(A2)		clear this item
	ANDI.W	#$DFFF,D7
	MOVE	D7,SR
;
; Now back to user mode
;
	MOVEQ	#4,D3
CLEAR_CHL ADDQ.L	#4,A1
	CLR.L	(A1,A6.L)
	DBF	D3,CLEAR_CHL
	MOVEQ	#80,D3
	MOVE.L	D3,4(A1,A6.L)
	BRA	NO_ERROR
*
* Read channel no -> D3
*
READ_CH	LEA	8(A3),A0
	CMP.L	A0,A5
	BNE	BAD_PARM	---->
	MOVE.W	CA_GTINT,A2
	JSR	(A2)
	BNE	BAD_EXIT
	MOVE.W	(A1,A6.L),D3
	CMPI.W	#1,D3		USE#1 means reset
	BEQ	RESET_CHL
*
* Track down data in channel table
*
	MOVE.L	BV_CHBAS(A6),A1
	MOVEQ	#40,D4
*
* Check channel no in D3 and convert to offset
*
CHAN_SEL	MULU.W	D4,D3
	ADD.L	A1,D3
	CMP.L	BV_CHP(A6),D3
	BGE	NOT_CHAN ---->
	MOVE.L	(A6,D3.L),D5
	BMI	NOT_CHAN ---->
	ADD.L	A1,D4
	MOVEQ	#MT_INF,D0
	TRAP	#1		A0 -> SYS VARS, D1 = JOB ID
	LEA	JB_SP,A2
	MOVEQ	#N_Jobs-1,D2	count
	TRAP	#0
;
; supervisor mode
;
	MOVE.W	SR,D7
	ORI	#$700,SR		stop interrupts
L2	CMP.L	(A2)+,D1		is job in list? . .
	DBEQ	D2,L2
	BEQ	CPY_CH1		. . yes, #1 already saved
	MOVEQ	#N_Jobs-1,D2	count again
L3	TST.B	-2(A2)		free space? . .
	SUBQ.L	#4,A2
	DBMI	D2,L3
	BPL	L6		. . not yet
	ADDQ.L	#4,A2
	BRA	L4		space found
;
; We must see if jobs in the list are current
;
L6	MOVEQ	#N_Jobs-1,D2
	MOVE.L	SV_JBBAS(A0),A0	pointer to job list
L5	MOVE.L	(A2)+,D6		Job ID in list
	MOVE.W	D6,D0
	LSL.W	#2,D0
	MOVE.L	(A0,D0.W),D0	pointer to job
	BMI	L4		Job dead - so space found
	MOVEA.L	D0,A5
	MOVE.W	JB_TAG(A5),D0	current job tag
	SWAP	D6
	CMP.W	D6,D0		all same job? . .
	DBNE	D2,L5
	BEQ	NO_ROOM		. . yes - so no room
L4	MOVE.L	D1,-4(A2) 	set job ID
	MOVE.L	(A6,D4.L),4*N_JOBS-4(A2)	set #ID
*
* Copy from offset D3 -> offset D4
*
CPY_CH1	MOVEQ	#9,D2
COPY_CH	MOVE.L	(A6,D3.L),(A6,D4.L)
	ADDQ.L	#4,D3
	ADDQ.L	#4,D4
	DBF	D2,COPY_CH
*
NO_ERROR1 ANDI.W	#$DFFF,D7
	MOVE	D7,SR
NO_ERROR	MOVEQ	#0,D0
	RTS
;
NO_ROOM	ANDI.W	#$DFFF,D7
	MOVE	D7,SR
;
; -> user mode
;
	MOVEQ	#-5,D0
	RTS
;
JB_SP	DCB.L	N_Jobs,-1
	DCB.L	N_Jobs,0
;
; JB_SP is a table of N_Jobs job IDs where USE is in operation.
; An entry with negative bottom word indicates a free space.
; The second set of four long words is for the corresponding
; #IDs for that SBASIC's channel 1.
;
; To find the largest window
; The size is put in the Basic Buffer
;
SW_REG	REG	D7/A0
;
SET_WIN	MOVEM.L	SW_REG,-(A7)
	BSR	OPE1
	MOVE.L	#MIN_WIDTH,D6
	MOVE.L	#MAX_WIDTH,D7
	MOVEA.L	BV_BFBAS(A6),A4	basic buffer rel to A6
	MOVEQ	#2,D5		"count"
	MOVEQ	#-1,D3		Timeout
	MOVE.W	#2,2(A4,A6.L)	Set height 2
	CLR.L	4(A4,A6.L)	Set origin to 0
LOOP1	MOVE.W	D7,(A4,A6.L)	Set maximum width 1st time, then height
;
; Top is in D7 : Bot in D6
; Loop until Top = Bot
; Size window depth (Top+Bot)/2
; If successful - set Bot = (Top+Bot)/2
;  else set Top = (Top+Bot)/2
;
LOOP	MOVE.W	D7,D0
	SUB.W	D6,D0
	BEQ	DONE1
	CMPI.W	#1,D0
	BEQ	H_DONE
	MOVE.W	D6,D0
	ADD.W	D7,D0
	LSR.W	#1,D0	new trial height
	BSR	TRY
	BNE	NOGO
	MOVE.W	(A4,A6.L),D6
	BRA	LOOP
NOGO	MOVE.W	(A4,A6.L),D7
	BRA	LOOP
;
DONE1	MOVE.W	D6,(A4,A6.L)
	SUBQ.W	#2,D5		0 for second time
	BNE	DONE2		finished
	ADDQ.L	#2,A4		point to height now
	MOVE.L	#MIN_HGT,D6
	MOVE.L	#MAX_HGT,D7
	BRA	LOOP1
;
DONE2	MOVEQ	#IO_CLOSE,D0
	TRAP	#2
	MOVEA.L	BV_BFBAS(A6),A1
	BCLR	#0,1(A1,A6.L)	Make x_size and . .
	BCLR	#0,3(A1,A6.L)	. . x_origin even
	MOVEM.L	(A7)+,SW_REG
	RTS
;
TRY	MOVE.W	D0,(A4,A6.L)
	LEA	-2(A4,D5.W),A1	Set A1 to start of definition block
	MOVEQ	#0,D1
	MOVEQ	#0,D2
	MOVEQ	#SD_WDEF,D0
	TRAP	#4		A1 is relative to A6
	TRAP	#3
	TST.L	D0
	RTS
;
H_DONE	MOVE.W	D7,D0
	BSR	TRY
	BNE	DONE1
	MOVE.W	D7,D6
	BRA	DONE1
;
MIN_WIDTH EQU	256
MAX_WIDTH EQU	2048
MIN_HGT	EQU	128
MAX_HGT	EQU	1024
